%% CIS II - Galen Calibration Pipeline - ScaleToBox
% Can Kocabalkanli and Nicolas Lamaison; 
% Programming Assignment 2 - Problem 1; CIS 1, Fall 2019

% Calculating "u" for q, qmax, qmin of a given frame element-wise
function [u] = ScaleToBox(q, qmax, qmin)

    ux = (q(1) - qmin(1))/(qmax(1) - qmin(1));
    uy = (q(2) - qmin(2))/(qmax(2) - qmin(2));
    uz = (q(3) - qmin(3))/(qmax(3) - qmin(3));
    
    ur = (q(4) - qmin(4))/(qmax(4) - qmin(4)); %theta
    up = (q(5) - qmin(5))/(qmax(5) - qmin(5)); %psi
    
    u = [ux;uy;uz; ur;up];
    
end