%% CIS II - Galen Calibration Pipeline - Calculate predicted (ground truth forward kinematics)
% Can Kocabalkanli

function [K_pre] = calculate_K_pre(T_b, C, T_tip)

n = size(C,3); %number of frames
K_pre = zeros(4,4,n);
for i = 1:n
    K_pre(:,:,i) = inv(T_b)*C(:,:,i)*inv(T_Tip);   
end
end