%% CIS II Galen Kinematic Calibration 

%K:
%k_dof:
%C:
%E:
%e_dof:
%T_b
%T_tip

%e_dof, k_dof will be 2D since each Dof vector is 6x1. So instead of
%6x1xn we store them as 6xn.

iter = 0;

while terminate == 0
    %For virtual, convert to matrices and set k_pre and K_pre from Python
    %Script. The script will give us k_pre_dof and k_dof
    %Then, we need to convert it with Galen's FWD Kinematics
    
    [k_pre_dof, k_dof] = getDataVirtual();
    n = size(k_dof,1);
    e_dof = zeros(6,1,n);
    K = zeros(4,4,n);
    K_pre = zeros(4,4,n);
    
    for r = 1:n
        fwdK = forwardKinematics(k_dof(r));
        k_t = fwdK(1:3);
        fwdKpre = forwardKinematics(k_pre_dof(r));
        k_pre_t = fwdKpre(1:3);
        %ASK MAX TO GET ROTATION
        Rk = 
        Rpre = 
        
        K(:,:,r) = [Rk k_t; 0 0 0 1];
        K_pre(:,:,r) = [Rpre k_pre_t; 0 0 0 1];
    end
    
    
    for i = 1:n
        E(:,:,i) = K(:,:,i)\K_pre(:,:,i); %inv(K)*K_pre
        e_dof(:,i) = skew2vector(E(:,:,i));
    
    end

    [S, qmax, qmin, k_cor] = correct(k_dof', e_dof'); % transpose to make then nx6
    %Change CorrectDistortion to be 5DOF

    %!! To use the correction coefficients on another dataset:!!
    %for k = 1:n_frames 
    %    for j = 1:n_markers
    %        G(:, j, k) = correctDistortion(G_dist(:, j, k), qmax, qmin, S);
    %    end
    %end

    
    %Assess Error:
    error = norm(k_cor - k_pre);
    iter = iter + 1;
    if (norm(error) < 0.5) || iter > 25
        terminate = 1;
    end
    %HAVE TO REASSIGN 
end


%[rho_2D, eta_2D] = mat3to2(k_dof, e_dof); %modify constants in the method for Galen!





